#include "abstractbooleandelegate.h"
#include <QComboBox>

AbstractBooleanDelegate::AbstractBooleanDelegate(QObject *parent, const QString &valueForTrue)
    : AbstractDelegate(parent)
{
    m_valueForTrue = valueForTrue;
}

QWidget *AbstractBooleanDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
              const QModelIndex &index) const
{
    Q_UNUSED(option)
    Q_UNUSED(index)
    QComboBox *comboBox = new QComboBox(parent);
    comboBox->addItem("True");
    comboBox->addItem("False");
    return comboBox;
}

void AbstractBooleanDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    QComboBox *comboBox = static_cast<QComboBox*>(editor);
    QString value = index.data(Qt::EditRole).toString();
    if (value == m_valueForTrue)
        comboBox->setCurrentIndex(0);
    else
        comboBox->setCurrentIndex(1);
}

void AbstractBooleanDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                            const QModelIndex &index) const
{
    QComboBox *comboBox = static_cast<QComboBox*>(editor);
    QString value;
    switch (comboBox->currentIndex())
    {
        case 0:
            value = m_valueForTrue;
            break;
        case 1:
            value = "";
            break;
        default:
            value = "";
            break;
    }
    model->setData(index, value);
}
