#ifndef ABSTRACTCONTROLOBJ_H
#define ABSTRACTCONTROLOBJ_H

#include "abstractobj.h"

// Properties
#include "geometrydataproperty.h"
#include "genericplainstringproperty.h"

class AbstractControlObj : public AbstractObj
{
public:
    AbstractControlObj(AbstractObj::ObjType objType);

    // Pure virtual functions
    virtual QString commandString() const = 0;
    virtual QString commandNameForDisplayRoleData() const = 0;
    virtual QString typeNameForDomElement() const = 0;

    // Re-implemented pure virtual functions
    virtual bool hasName() const;

    // Properties
    GenericPlainStringProperty *nameProperty;
    GeometryDataProperty *xProperty;
    GeometryDataProperty *yProperty;
    GeometryDataProperty *xSizeProperty;
    GeometryDataProperty *ySizeProperty;
};

#endif // ABSTRACTCONTROLOBJ_H
