#include "abstractmultimodalitydelegate.h"

#include <QComboBox>

AbstractMultiModalityDelegate::AbstractMultiModalityDelegate(QObject *parent)
    : AbstractDelegate(parent)
{
}

QWidget *AbstractMultiModalityDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
              const QModelIndex &index) const
{
    Q_UNUSED(option)
    Q_UNUSED(index)
    QComboBox *comboBox = new QComboBox(parent);
    for (int i=0; i<m_displayRoleModalities.count(); i++)
        comboBox->addItem(m_displayRoleModalities.at(i));
    return comboBox;
}

void AbstractMultiModalityDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    QComboBox *comboBox = static_cast<QComboBox*>(editor);
    int comboBoxIndex = m_editRoleModalities.indexOf(index.data(Qt::EditRole).toString());
    comboBox->setCurrentIndex(comboBoxIndex);
}

void AbstractMultiModalityDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                            const QModelIndex &index) const
{
    QComboBox *comboBox = static_cast<QComboBox*>(editor);
    QString data = m_editRoleModalities.at(comboBox->currentIndex());
    model->setData(index, data);
}

void AbstractMultiModalityDelegate::setModalities(const QList<QString> &editRoleModalities,
                                                 const QList<QString> &displayRoleModalities)
{
    m_editRoleModalities = editRoleModalities;
    m_displayRoleModalities = displayRoleModalities;
}
