#include "checkboxobj.h"

CheckBoxObj::CheckBoxObj()
    :AbstractControlObj(AbstractObj::CheckBox)
{
    xSizeProperty->setValue(".");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    defaultProperty =
            new GenericLabeledStringProperty("default", "Default", AbstractDelegate::DefaultNumVal);
    appendProperty(defaultProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    groupBoxProperty =
            new GenericBooleanProperty("groupbox", "Group box", AbstractDelegate::GroupBox);
    appendProperty(groupBoxProperty);

    onClickOnProperty =
            new GenericLabeledStringProperty("onclickon", "On click on", AbstractDelegate::IAction);
    appendProperty(onClickOnProperty);

    onClickOffProperty =
            new GenericLabeledStringProperty("onclickoff", "On click off", AbstractDelegate::IAction);
    appendProperty(onClickOffProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString CheckBoxObj::commandString() const
{
    return "CHECKBOX" + standardInnerCommandString();
}

QString CheckBoxObj::commandNameForDisplayRoleData() const
{
    return "Checkbox";
}

QString CheckBoxObj::typeNameForDomElement() const
{
    return "checkbox";
}

