#include "colorobj.h"

ColorObj::ColorObj()
    : AbstractControlObj(AbstractObj::Color)
{
    xSizeProperty->setValue("80");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    defaultColorProperty = new DefaultColorProperty;
    appendProperty(defaultColorProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    onChangeProperty =
            new GenericLabeledStringProperty("onchange", "On change", AbstractDelegate::IAction);
    appendProperty(onChangeProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString ColorObj::commandString() const
{
    return "COLOR" + standardInnerCommandString();
}

QString ColorObj::commandNameForDisplayRoleData() const
{
    return "Color";
}

QString ColorObj::typeNameForDomElement() const
{
    return "color";
}

