#ifndef COLOROBJ_H
#define COLOROBJ_H

#include "abstractcontrolobj.h"

// Properties
#include "genericlabeledstringproperty.h"
#include "genericbooleanproperty.h"
#include "defaultcolorproperty.h"

class ColorObj : public AbstractControlObj
{
public:
    ColorObj();

    // Re-implemented pure virtual functions
    virtual QString commandString() const;
    virtual QString commandNameForDisplayRoleData() const;
    virtual QString typeNameForDomElement() const;

    // Properties
    GenericLabeledStringProperty *labelProperty;
    GenericLabeledStringProperty *errorProperty;
    DefaultColorProperty *defaultColorProperty;
    GenericBooleanProperty *noMemoryProperty;
    GenericLabeledStringProperty *onChangeProperty;
    GenericLabeledStringProperty *optionProperty;
    GenericLabeledStringProperty *toolTipProperty;
};

#endif // COLOROBJ_H
