#ifndef COLORSETTER_H
#define COLORSETTER_H

#include "abstractsetter.h"
#include <QSpinBox>
#include <QPushButton>
#include <QLabel>
#include <QAction>

class ColorSetter : public AbstractSetter
{
Q_OBJECT

public:
    ColorSetter(QWidget *parent);
    void setData(const QString &rgbString);
    QString data();

private:
    // GUI
    QSpinBox *redSpinBox;
    QSpinBox *greenSpinBox;
    QSpinBox *blueSpinBox;
    QLabel *redLabel;
    QLabel *greenLabel;
    QLabel *blueLabel;
    QLabel *notSpecifiedLabel;
    QPushButton *button;

    // Actions
    QAction *advancedColorPeekerAction;
    QAction *simpleColorPeekerAction;
    QAction *setNotSpecifiedAction;

    // IsSpecified
    bool m_isSpecified;

private slots:
    void onAdvancedColorPeekerActionTriggered();
    void onSimpleColorPeekerActionTriggered();
    void onSetNotSpecifiedActionTriggered();
};

#endif // COLORSETTER_H
