#ifndef COMBOBOXOBJ_H
#define COMBOBOXOBJ_H

#include "abstractcontrolobj.h"

// Properties
#include "genericbooleanproperty.h"
#include "contentsproperty.h"
#include "comboboxtypeproperty.h"

class ComboBoxObj : public AbstractControlObj
{
public:
    ComboBoxObj();

    // Re-implemented pure virtual functions
    virtual QString commandString() const;
    virtual QString commandNameForDisplayRoleData() const;
    virtual QString typeNameForDomElement() const;

    // Properties
    GenericLabeledStringProperty *labelProperty;
    GenericLabeledStringProperty *errorProperty;
    ComboBoxTypeProperty *comboBoxTypeProperty;
    GenericLabeledStringProperty *defaultProperty;
    GenericBooleanProperty *noMemoryProperty;
    ContentsProperty *contentsProperty;
    GenericLabeledStringProperty *valuesProperty;
    GenericBooleanProperty *appendPropertyProperty;
    GenericLabeledStringProperty *onSelChangeProperty;
    GenericLabeledStringProperty *onSelChangeListProperty;
    GenericLabeledStringProperty *optionProperty;
    GenericLabeledStringProperty *toolTipProperty;
};

#endif // COMBOBOXOBJ_H
