#ifndef CONTENTSSETTER_H
#define CONTENTSSETTER_H

#include "abstractsetter.h"
#include <QLineEdit>
#include <QPushButton>
#include <QList>
#include <QStringList>

class MenuItem
{
public:
    MenuItem(const QString &itemName, const QString &itemValue)
    {
        this->itemName = itemName;
        this->itemValue = itemValue;
    }

    QString itemName;
    QString itemValue;
};

class ContentsSetter : public AbstractSetter
{
Q_OBJECT

public:
    explicit ContentsSetter(const QStringList &userDefinedLists, QWidget *parent);
    void setContentsData(const QString &data);
    QString contentsData() const;

private:
    // GUI
    QLineEdit *lineEdit;
    QPushButton *button;

    // Functions
    QString nameFromValue(const QString &value);

private slots:
    void onMenuActionTriggered();
    void onManualEntryActionTriggered();
    void onUserDefinedListMenuItemTriggered();
};

#endif // CONTENTSSETTER_H
