#ifndef DEBUGREPORTMODEL_H
#define DEBUGREPORTMODEL_H

#include <QAbstractItemModel>
#include <QList>
#include "debugreportitem.h"
#include "document.h"

class DebugReportModel : public QAbstractItemModel
{
Q_OBJECT

public:
    explicit DebugReportModel(Document *document, QObject *parent = 0);
    ~DebugReportModel();

    // Re-implemented pure virtual functions
    virtual int rowCount(const QModelIndex &parent) const;
    virtual int	columnCount(const QModelIndex & parent = QModelIndex()) const;
    virtual QVariant data(const QModelIndex & index, int role = Qt::DisplayRole) const;
    virtual QModelIndex	parent(const QModelIndex & index) const;
    virtual QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const;

    // Other functions
    void appendDebugReportItem(DebugReportItem *debugReportItem);
    void clear();
    void updateReport();

private:
    QList<DebugReportItem*> debugReportItems;
    Document *document;
    QString objName(AbstractObj *obj);

    // Debug functions
    void debugVersion();
    void debugPosition();
    void debugUniqueNames();
    void debugAtLeastOneDialogExist();
};

#endif // DEBUGREPORTMODEL_H
