#ifndef DEBUGREPORTWINDOW_H
#define DEBUGREPORTWINDOW_H

#include <QWidget>
#include <QTextEdit>
#include <QSplitter>
#include "document.h"
#include "debugreportmodel.h"
#include "debugreportview.h"

class DebugReportWindow : public QWidget
{
Q_OBJECT

public:
    explicit DebugReportWindow(Document *document, QWidget *parent = 0);
    QByteArray splitterSaveState();
    void restoreSplitterState(const QByteArray &state);

private:
    DebugReportModel *debugReportModel;
    DebugReportView *debugReportView;
    QTextEdit *textEdit;
    QSplitter *splitter;

public slots:
    void updateReport();

private slots:
    void onSelectionChangedInDebugReportView(const QItemSelection &selected,
                                             const QItemSelection &deselected);
};

#endif // DEBUGREPORTWINDOW_H
