#include "defaultcolorproperty.h"
#include <QStringList>

DefaultColorProperty::DefaultColorProperty()
    : GenericLabeledStringProperty("default", "Default", AbstractDelegate::Color)
{
}

QVariant DefaultColorProperty::updateDisplayRoleDataString(const QString &valueString)
{
    if (valueString.isEmpty()) return "Not specified";

    QStringList rgbStringList = valueString.split(" ");
    if (rgbStringList.isEmpty()) return "";
    if (rgbStringList.count() != 3) return "";

    // Red
    bool okConversionToIntRed;
    int red = rgbStringList.at(0).toInt(&okConversionToIntRed);

    // Green
    bool okConversionToIntGreen;
    int green = rgbStringList.at(1).toInt(&okConversionToIntGreen);

    // Blue
    bool okConversionToIntBlue;
    int blue = rgbStringList.at(2).toInt(&okConversionToIntBlue);

    if (okConversionToIntRed && okConversionToIntGreen && okConversionToIntBlue)
        return QString("R: %1 G: %2 B: %3").arg(red).arg(green).arg(blue);
    else
        return QVariant();
}
