#ifndef DEFAULTSETTER_H
#define DEFAULTSETTER_H

#include "abstractsetter.h"
#include <QLineEdit>
#include <QSpinBox>
#include <QPushButton>
#include <QMenu>

class DefaultSetter : public AbstractSetter
{
Q_OBJECT

public:
    enum DefaultSetterType {NumVal, StrVal};
    DefaultSetter(DefaultSetter::DefaultSetterType defaultSetterType, QWidget *parent);
    void setDefaultValue(const QString &value);
    QString defaultValue();

private:
    // GUI
    QLineEdit *lineEdit;
    QSpinBox *spinBox;
    QPushButton *button;

    // Main menu
    QMenu *mainMenu;

    // Functions
    void createMenu();

    DefaultSetter::DefaultSetterType m_defaultSetterType;

private slots:
    void onNumberSpecifiedActionTriggered();
    void onCNameActionTriggered();
    void onRNameActionTriggered();
    void onENameActionTriggered();
    void onSNameActionTriggered();
    void onCharActionTriggered();
    void onGlobalNameActionTriggered();
    void onClearActionTriggered();
};

#endif // DEFAULTSETTER_H
