#include "defineobj.h"

DefineObj::DefineObj()
    : AbstractObj(AbstractObj::Define)
{
    nameProperty = new GenericPlainStringProperty("name", "Name", AbstractDelegate::Name);
    appendProperty(nameProperty);

    definitionProperty = new GenericPlainStringProperty("definition", "Definition",
                                                        AbstractDelegate::DefineDefinition);
    definitionProperty->setValue(".");
    appendProperty(definitionProperty);
}

QString DefineObj::commandString() const
{
    return "DEFINE" + standardInnerCommandString();
}

QString DefineObj::commandNameForDisplayRoleData() const
{
    return "Define";
}

QString DefineObj::typeNameForDomElement() const
{
    return "define";
}

bool DefineObj::hasName() const
{
    return true;
}
