#ifndef DOCUMENT_H
#define DOCUMENT_H

#include <QList>
#include <QString>
#include "rootobj.h"

class Document
{
public:
    Document();
    void appendObj(AbstractObj* obj);
    void insertObj(AbstractObj *obj, int pos);
    void swapObjects(int parentRow, int row1, int row2);
    void moveObjUp(int parentRow, int row);
    void moveObjDown(int parentRow, int row);
    void deleteObjAt(int pos);
    AbstractObj *objAt(int pos);
    int objCount() const;
    inline AbstractObj *root() const {return m_rootObj;}
    QString commandString() const;
    bool writeVisuaFile(const QString &fileName) const;
    bool loadVisuaFile(const QString &fileName);
    bool writeStataDlgCodeOnFile(const QString &fileName) const;
    void clear();
    bool hasAtLeastOneChildControlObjBeforeRow(int row) const;
    QList<AbstractObj*> objListFromVisuaCode(const QString &visuaCode);


private:
    RootObj *m_rootObj;

};

#endif // DOCUMENT_H
