#include "editobj.h"

// Properties
#include "genericlabeledstringproperty.h"
#include "genericbooleanproperty.h"
#include "maxforeditproperty.h"

EditObj::EditObj()
    : AbstractControlObj(AbstractObj::Edit)
{
    xSizeProperty->setValue("200");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    defaultProperty =
            new GenericLabeledStringProperty("default", "Default", AbstractDelegate::DefaultStrVal);
    appendProperty(defaultProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    maxForEditProperty = new MaxForEditProperty;
    appendProperty(maxForEditProperty);

    numOnlyProperty =
            new GenericBooleanProperty("numonly", "Numeric only", AbstractDelegate::NumOnly);
    appendProperty(numOnlyProperty);

    passwordProperty =
            new GenericBooleanProperty("password", "Password", AbstractDelegate::Password);
    appendProperty(passwordProperty);

    onChangeProperty =
            new GenericLabeledStringProperty("onchange", "On change", AbstractDelegate::IAction);
    appendProperty(onChangeProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString EditObj::commandString() const
{
    return "EDIT" + standardInnerCommandString();
}

QString EditObj::commandNameForDisplayRoleData() const
{
    return "Edit";
}

QString EditObj::typeNameForDomElement() const
{
    return "edit";
}
