#include "expobj.h"

ExpObj::ExpObj()
    : AbstractControlObj(AbstractObj::Exp)
{
    xSizeProperty->setValue("200");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    defaultProperty =
            new GenericLabeledStringProperty("default", "Default", AbstractDelegate::DefaultStrVal);
    appendProperty(defaultProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    onChangeProperty =
            new GenericLabeledStringProperty("onchange", "On change", AbstractDelegate::IAction);
    appendProperty(onChangeProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString ExpObj::commandString() const
{
    return "EXP" + standardInnerCommandString();
}

QString ExpObj::commandNameForDisplayRoleData() const
{
    return "Expression";
}

QString ExpObj::typeNameForDomElement() const
{
    return "exp";
}

