#include "fileforcanvas.h"

FileForCanvas::FileForCanvas(const QRect &rect, const QString &label,
                             const QString &buttonWidth, const QWidget *widget)
    : AbstractObjForCanvas(rect), widget(widget)
{
    bool conversionToIntIsOk;
    int buttonWidthToInt = buttonWidth.toInt(&conversionToIntIsOk);
    if (!conversionToIntIsOk) buttonWidthToInt = 75;

    // Line edit
    styleOptionLineEdit.initFrom(widget);
    if (rect.width() - 75 - 4 > 0)
    {
        styleOptionLineEdit.rect.setX(rect.x());
        styleOptionLineEdit.rect.setY(rect.y());
        styleOptionLineEdit.rect.setWidth(rect.width() - buttonWidthToInt - 1);
        styleOptionLineEdit.rect.setHeight(rect.height());
    }
    else
    {
        styleOptionLineEdit.rect.setX(0);
        styleOptionLineEdit.rect.setY(0);
        styleOptionLineEdit.rect.setWidth(0);
        styleOptionLineEdit.rect.setHeight(0);
    }

    // Button
    styleOptionButton.initFrom(widget);
    styleOptionButton.rect.setX(rect.x() + rect.width() - buttonWidthToInt);
    styleOptionButton.rect.setY(rect.y());
    styleOptionButton.rect.setWidth(buttonWidthToInt);
    styleOptionButton.rect.setHeight(rect.height());
    styleOptionButton.text = label;
}

void FileForCanvas::draw(QPainter *painter) const
{
    widget->style()->drawPrimitive(QStyle::PE_FrameLineEdit, &styleOptionLineEdit, painter, widget);
    widget->style()->drawControl(QStyle::CE_PushButton, &styleOptionButton, painter, widget);
}
