#include "fileobj.h"

FileObj::FileObj()
    : AbstractControlObj(AbstractObj::File)
{
    xSizeProperty->setValue("200");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    defaultProperty =
            new GenericLabeledStringProperty("default", "Default", AbstractDelegate::DefaultStrVal);
    appendProperty(defaultProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    buttonWidthProperty =
            new GenericLabeledStringProperty("buttonwidth", "Button width",
                                             AbstractDelegate::FileButtonWidth);
    appendProperty(buttonWidthProperty);

    dialogTitleForFileObjProperty =
            new GenericLabeledStringProperty("dialogtitle", "Dialog title", AbstractDelegate::GenericString);
    appendProperty(dialogTitleForFileObjProperty);

    saveProperty =
            new GenericBooleanProperty("save", "Save", AbstractDelegate::Save);
    appendProperty(saveProperty);

    multiSelectProperty =
            new GenericBooleanProperty("multiselect", "Multiple selection", AbstractDelegate::MultiSelect);
    appendProperty(multiSelectProperty);

    filterProperty =
            new GenericLabeledStringProperty("filter", "Filter", AbstractDelegate::GenericString);
    appendProperty(filterProperty);

    onChangeProperty =
            new GenericLabeledStringProperty("onchange", "On change", AbstractDelegate::IAction);
    appendProperty(onChangeProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString FileObj::commandString() const
{
    return "FILE" + standardInnerCommandString();
}

QString FileObj::commandNameForDisplayRoleData() const
{
    return "File";
}

QString FileObj::typeNameForDomElement() const
{
    return "file";
}

