#ifndef GENERICBOOLEANPROPERTY_H
#define GENERICBOOLEANPROPERTY_H

#include "abstractproperty.h"

class GenericBooleanProperty : public AbstractProperty
{
public:
    GenericBooleanProperty(const QString &nameForDomElement, const QString &nameForDisplayRoleData,
                           AbstractDelegate::DelegateType delegateType = AbstractDelegate::GenericString);

    // Re-implemented pure virtual functions
    virtual QVariant updateDisplayRoleDataString(const QString &valueString);
    virtual QString updateCommandString(const QString &valueString);
    virtual QString domElementName() const;
    virtual QVariant propertyNameForDisplayRoleData() const;
    virtual bool isRequired() const;
    virtual AbstractDelegate::DelegateType delegateForProperty() const;

private:
    QString m_nameForDomElement;
    QString m_nameForDisplayRoleData;
    AbstractDelegate::DelegateType m_delegateType;
};

#endif // GENERICBOOLEANPROPERTY_H
