#include "genericlabeledstringproperty.h"

GenericLabeledStringProperty::GenericLabeledStringProperty(const QString &nameForDomElement,
                                                           const QString &nameForDisplayRoleData,
                                                           AbstractDelegate::DelegateType delegateType)
{
    m_nameForDomElement = nameForDomElement;
    m_nameForDisplayRoleData = nameForDisplayRoleData;
    m_delegateType = delegateType;
}

QVariant GenericLabeledStringProperty::updateDisplayRoleDataString(const QString &valueString)
{
    return valueString;
}

QString GenericLabeledStringProperty::updateCommandString(const QString &valueString)
{
    if (valueString.isEmpty())
        return "";
    else
        return m_nameForDomElement + "(" + valueString + ")";
}

QString GenericLabeledStringProperty::domElementName() const
{
    return m_nameForDomElement;
}

QVariant GenericLabeledStringProperty::propertyNameForDisplayRoleData() const
{
    return m_nameForDisplayRoleData;
}

bool GenericLabeledStringProperty::isRequired() const
{
    return false;
}

AbstractDelegate::DelegateType GenericLabeledStringProperty::delegateForProperty() const
{
    return m_delegateType;
}
