#include "iactiondelegate.h"
#include "iactionsetter.h"
#include "abstractobj.h"
#include <QSortFilterProxyModel>
#include "iactioncompleter.h"

#include <QDebug>

IActionDelegate::IActionDelegate(QObject *parent)
    : AbstractDelegate(parent)
{
}

QWidget *IActionDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                      const QModelIndex &index) const
{
    Q_UNUSED(option)

    // Retrive source model
    const QSortFilterProxyModel *proxyModel = static_cast<const QSortFilterProxyModel*>(index.model());
    QModelIndex sourceIndex = proxyModel->mapToSource(index);
    const QAbstractItemModel *sourceModel = sourceIndex.model();

    // Completer
    IActionCompleter *completer = new IActionCompleter(sourceModel, parent);

    // IAction setter
    AbstractObj* obj = static_cast<AbstractObj*>(index.internalPointer());
    IActionSetter *iActionSetter = new IActionSetter(obj->objType(), completer, sourceModel, parent);
    return iActionSetter;
}

void IActionDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
    IActionSetter *iActionSetter = static_cast<IActionSetter*>(editor);
    iActionSetter->setIActionData(index.data(Qt::EditRole).toString());
}

void IActionDelegate::setModelData(QWidget *editor, QAbstractItemModel *model,
                                   const QModelIndex &index) const
{
    IActionSetter *iActionSetter = static_cast<IActionSetter*>(editor);
    model->setData(index, iActionSetter->iActionData());
}

