#ifndef IACTIONSETTER_H
#define IACTIONSETTER_H

#include "abstractsetter.h"
#include <QLineEdit>
#include <QPushButton>
#include <QAction>
#include "abstractobj.h"
#include "iactioncompleter.h"

class IActionSetter : public AbstractSetter
{
Q_OBJECT

public:
    explicit IActionSetter(AbstractObj::ObjType objType,
                           IActionCompleter *completer,
                           const QAbstractItemModel *sourceModel,
                           QWidget *parent);
    void setIActionData(const QString &data);
    QString iActionData() const;

private:
    // GUI
    QLineEdit *lineEdit;
    QPushButton *button;

    // Main menu
    QMenu *mainMenu;

    // Member function actions for controls
    QList<QAction*> standardIActions;
    QList<QAction*> checkboxIActions;
    QList<QAction*> radioIActions;
    QList<QAction*> spinnerIActions;
    QList<QAction*> editIActions;
    QList<QAction*> varlistIActions;
    QList<QAction*> varnameIActions;
    QList<QAction*> fileIActions;
    QList<QAction*> listboxIActions;
    QList<QAction*> comboboxIActions;
    QList<QAction*> buttonIActions;
    QList<QAction*> textIActions;
    QList<QAction*> textboxIActions;
    QList<QAction*> groupboxIActions;
    QList<QAction*> frameIActions;
    QList<QAction*> colorIActions;
    QList<QAction*> expIActions;

    // Functions
    void createActionMenu(const QAbstractItemModel *sourceModel);
    void createMemberFunctionForThisControlMenu(AbstractObj::ObjType objType);
    void createOtherActionMenu();
    void createMemberFunctionActionsForControls();
    void createMemberFunctionMenus();
    QAction *memberFunctionAction(const QString &displayText, const QString &actionData);
    QList<QAction*> getActionsForControl(AbstractObj::ObjType objType);

private slots:
    void onDoNothingActionTriggered();
    void onClearAllActionTriggered();
    void onIActionChosen_SetText();
    void onIActionChosen_InsertText();
};

#endif // IACTIONSETTER_H
