#include "includefilenamesetter.h"
#include <QHBoxLayout>
#include <QFileDialog>
#include <QFileInfo>
#include <QDebug>

IncludeFileNameSetter::IncludeFileNameSetter(QWidget *parent) :
    AbstractSetter(parent)
{
    // Layout
    QHBoxLayout *layout = new QHBoxLayout;
    layout->setMargin(0);
    layout->setContentsMargins(0, 0, 0, 0);
    layout->setSpacing(0);
    setLayout(layout);

    // Line edit
    lineEdit = new QLineEdit;
    lineEdit->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Expanding);
    lineEdit->setFocus();
    layout->addWidget(lineEdit);

    // Button
    button = new QToolButton;
    button->setText("...");
    button->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Minimum);
    button->setMinimumWidth(20);
    button->setMaximumWidth(20);
    connect(button, SIGNAL(clicked()), this, SLOT(onButtonClicked()));
    layout->addWidget(button);
}

void IncludeFileNameSetter::setData(const QString &data)
{
    lineEdit->setText(data);
}

QString IncludeFileNameSetter::data()
{
    return lineEdit->text();
}

void IncludeFileNameSetter::onButtonClicked()
{
    QString fileName = QFileDialog::getOpenFileName(
                this,
                "Choose file name",
                ".",
                "Dialog resources (*.idlg)");
    if (!fileName.isEmpty())
    {
        QFileInfo fileInfo(fileName);
        lineEdit->setText(fileInfo.baseName());
    }
}
