#ifndef LISTCONTENTSETTER_H
#define LISTCONTENTSETTER_H

#include "abstractsetter.h"
#include <QToolButton>
#include <QMenu>
#include <QStringListModel>
#include <QAction>
#include "listcontentlistview.h"
#include "listcontentmodel.h"


class ListContentSetter : public AbstractSetter
{
Q_OBJECT

public:
    ListContentSetter(QWidget *parent);
    void setItemList(const QStringList &stringList);
    QStringList itemList();

private:
    // GUI
    ListContentListView *listView;
    QToolButton *addButton;
    QToolButton *removeButton;
    QToolButton *upButton;
    QToolButton *downButton;

    // Model
    ListContentModel *model;

private slots:
    void onAddButtonClicked();
    void onRemoveButtonClicked();
    void onUpButtonClicked();
    void onDownButtonClicked();
};

#endif // LISTCONTENTSETTER_H
