#include "namedelegate.h"
#include <QLineEdit>

NameDelegate::NameDelegate(QObject *parent)
    : GenericStringDelegate(parent)
{
}

QWidget *NameDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                      const QModelIndex &index) const
{
    QWidget *editor = GenericStringDelegate::createEditor(parent, option, index);
    QLineEdit *lineEdit = static_cast<QLineEdit*>(editor);
    lineEdit->setMaxLength(32);
    QRegExp regExp("[a-zA-Z_]{1,1}[a-zA-Z_0-9]{0,31}");
    QRegExpValidator *regExpValidator = new QRegExpValidator(regExp, lineEdit);
    lineEdit->setValidator(regExpValidator);
    return lineEdit;
}
