#ifndef OBJECTBOXMODEL_H
#define OBJECTBOXMODEL_H

#include <QAbstractItemModel>
#include <QMimeData>
#include "objectboxitem.h"

class ObjectBoxModel : public QAbstractItemModel
{
Q_OBJECT

public:
    explicit ObjectBoxModel(QObject *parent = 0);

    // Virtual functions
    virtual QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const;
    virtual QModelIndex parent(const QModelIndex &index) const;
    virtual int rowCount(const QModelIndex &parent = QModelIndex()) const;
    virtual int columnCount(const QModelIndex &parent = QModelIndex()) const;
    virtual QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const;
    virtual Qt::ItemFlags flags(const QModelIndex &index) const;
    virtual QMimeData *mimeData(const QModelIndexList &indexes) const;

private:
    ObjectBoxItem *m_rootItem;
};

#endif // OBJECTBOXMODEL_H
