#ifndef OBJECTBOXVIEW_H
#define OBJECTBOXVIEW_H

#include <QTreeView>
#include <QSortFilterProxyModel>
#include <QMouseEvent>
#include "objectboxmodel.h"

class ObjectBoxView : public QTreeView
{
Q_OBJECT

public:
    explicit ObjectBoxView(QWidget *parent = 0);
    void setFilterString(const QString &string);

private:
    // Models
    ObjectBoxModel *sourceModel;
    QSortFilterProxyModel *proxyModel;

    bool controlsButtonIsExpanded;
    bool specialButtonsButtonIsExpanded;
    bool miscellaneousButtonIsExpanded;

private slots:
    void onControlsButtonClicked();
    void onSpecialButtonsButtonClicked();
    void onMiscellaneousButtonClicked();

protected:
    virtual void startDrag(Qt::DropActions supportedActions);
//    void mouseMoveEvent(QMouseEvent *event);
};

#endif // OBJECTBOXVIEW_H
