#include "objectlistdockwidget.h"
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QToolButton>
#include <QDebug>
#include "model.h"

ObjectListDockWidget::ObjectListDockWidget(ObjectListView *objectListView, QWidget *parent) :
    QDockWidget(parent)
{
    setWindowTitle("Object list");
    setAllowedAreas(Qt::LeftDockWidgetArea | Qt::RightDockWidgetArea);

    QWidget *innerWidget = new QWidget;

    QVBoxLayout *mainLayout = new QVBoxLayout;
    mainLayout->setSpacing(0);
    mainLayout->setMargin(0);
    innerWidget->setLayout(mainLayout);

    QToolButton *upButton = new QToolButton(this);
    upButton->setToolTip("Move object up");
    upButton->setIcon(QIcon(":/images/icons/up.png"));
    connect(upButton, SIGNAL(clicked()), objectListView, SLOT(onUpButtonClicked()));

    QToolButton *downButton = new QToolButton(this);
    downButton->setToolTip("Move object down");
    downButton->setIcon(QIcon(":/images/icons/down.png"));
    connect(downButton, SIGNAL(clicked()), objectListView, SLOT(onDownButtonClicked()));

    QHBoxLayout *toolButtonsLayout = new QHBoxLayout;
    toolButtonsLayout->addWidget(upButton);
    toolButtonsLayout->addWidget(downButton);
    toolButtonsLayout->addStretch();
    toolButtonsLayout->setSpacing(0);

    mainLayout->addLayout(toolButtonsLayout);
    mainLayout->addWidget(objectListView);

    setWidget(innerWidget);
}
