#ifndef OBJECTLISTPROXYMODEL_H
#define OBJECTLISTPROXYMODEL_H

#include <QAbstractProxyModel>
#include "abstractobj.h"
#include <QStringList>

class ObjectListProxyModel : public QAbstractProxyModel
{
Q_OBJECT

public:
    explicit ObjectListProxyModel(QObject *parent = 0);

    virtual QModelIndex mapFromSource(const QModelIndex &sourceIndex) const;
    virtual QModelIndex mapToSource(const QModelIndex &proxyIndex) const;
    virtual QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const;
    virtual QModelIndex parent(const QModelIndex &child) const;
    virtual int rowCount(const QModelIndex &parent = QModelIndex()) const;
    virtual int columnCount(const QModelIndex &parent = QModelIndex()) const;
    virtual QVariant data(const QModelIndex &index, int role) const;
    virtual QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
    virtual Qt::ItemFlags flags(const QModelIndex &index) const;
    virtual bool setData(const QModelIndex &index, const QVariant &value, int role = Qt::EditRole);
    virtual bool dropMimeData(const QMimeData *data, Qt::DropAction action,
                              int row, int column, const QModelIndex &referenceIndex);
    virtual QStringList mimeTypes() const;
    virtual Qt::DropActions supportedDropActions() const;
    virtual bool removeRows(int row, int count, const QModelIndex &parent = QModelIndex());

private:
    bool objCanBeDroppedInsideDialog(AbstractObj::ObjType objType);

public slots:
    void onMainModelWasResetted();
    bool moveItemUp(const QModelIndex &parent, int row);
    bool moveItemDown(const QModelIndex &parent, int row);

signals:
    void newItemAppended(const QModelIndex &index);
    void wasAttemptedToInsertProhibitedObjInDialog();
};

#endif // OBJECTLISTPROXYMODEL_H
