#ifndef OBJECTLISTVIEW_H
#define OBJECTLISTVIEW_H

#include <QTreeView>
#include <QContextMenuEvent>
#include <QAction>

class ObjectListView : public QTreeView
{
Q_OBJECT

public:
    explicit ObjectListView(QWidget *parent = 0);

protected:
    virtual void contextMenuEvent(QContextMenuEvent *event);

private:
    QMenu *contextMenu;
    QMenu *addControlMenu;
    QAction *addCheckboxAction;
    QAction *addRadioAction;
    QAction *addSpinnerAction;
    QAction *addEditAction;
    QAction *addVarlistAction;
    QAction *addVarnameAction;
    QAction *addFileAction;
    QAction *addListboxAction;
    QAction *addComboboxAction;
    QAction *addButtonAction;
    QAction *addTextAction;
    QAction *addTextboxAction;
    QAction *addGroupboxAction;
    QAction *addFrameAction;
    QAction *addColorAction;
    QAction *addExpAction;
    QAction *deleteObjectAction;

public slots:
    void onSelectionChangedInCanvas(const QItemSelection &selected, const QItemSelection &deselected);
    void onUpButtonClicked();
    void onDownButtonClicked();

private slots:
    void onAddControlActionTriggered();
    void onDeleteObjectActionTriggered();

signals:
    void controlAddedToDialog();
    void itemMovedUp();
    void itemMovedDown();

};

#endif // OBJECTLISTVIEW_H
