#ifndef OBJECTPROPERTIESPROXYMODEL_H
#define OBJECTPROPERTIESPROXYMODEL_H

#include <QAbstractProxyModel>
#include <QItemSelection>

class ObjectPropertiesProxyModel : public QAbstractProxyModel
{
Q_OBJECT

public:
    explicit ObjectPropertiesProxyModel(QObject *parent = 0);
    virtual QModelIndex mapFromSource(const QModelIndex &sourceIndex) const;
    virtual QModelIndex mapToSource(const QModelIndex &proxyIndex) const;
    virtual QModelIndex index(int row, int column, const QModelIndex &parent = QModelIndex()) const;
    virtual QModelIndex parent(const QModelIndex &child) const;
    virtual int rowCount(const QModelIndex &parent = QModelIndex()) const;
    virtual int columnCount(const QModelIndex &parent = QModelIndex()) const;
    virtual QVariant data(const QModelIndex &index, int role) const;
    virtual QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
    Qt::ItemFlags flags(const QModelIndex &index) const;
    bool setData(const QModelIndex &index, const QVariant &value, int role = Qt::EditRole);

private:
    int selectedPrimaryRow;
    int selectedSecondaryRow;

public slots:
    void onSelectionChanged(QItemSelection selected, QItemSelection deselected);
    void onMainModelWasResetted();
    void onItemMovedUp();
    void onItemMovedDown();
};

#endif // OBJECTPROPERTIESPROXYMODEL_H
