#include "objectpropertiesview.h"
#include "abstractobj.h"

// Temporary
#include <QDebug>

ObjectPropertiesView::ObjectPropertiesView(QWidget *parent) :
    QTreeView(parent)
{
    setIndentation(0);

    //// Delegates
    // GenericStringDelegate
    genericStringDelegate = new GenericStringDelegate(this);
    delegates.insert(AbstractDelegate::GenericString, genericStringDelegate);
    // Name
    nameDelegate = new NameDelegate(this);
    delegates.insert(AbstractDelegate::Name, nameDelegate);
    // OperatingSystemDelegate
    operatingSystemDelegate = new OperatingSystemDelegate(this);
    delegates.insert(AbstractDelegate::OperatingSystem, operatingSystemDelegate);
    // GeometryDataDelegate
    geometryDataDelegate = new GeometryDataDelegate(this);
    delegates.insert(AbstractDelegate::GeometryData, geometryDataDelegate);
    // NoMemoryDelegate
    noMemoryDelegate = new NoMemoryDelegate(this);
    delegates.insert(AbstractDelegate::NoMemory, noMemoryDelegate);
    // GroupBoxDelegate
    groupBoxDelegate = new GroupBoxDelegate(this);
    delegates.insert(AbstractDelegate::GroupBox, groupBoxDelegate);
    // NumOnlyDelegate
    numOnlyDelegate = new NumOnlyDelegate(this);
    delegates.insert(AbstractDelegate::NumOnly, numOnlyDelegate);
    // PasswordDelegate
    passwordDelegate = new PasswordDelegate(this);
    delegates.insert(AbstractDelegate::Password, passwordDelegate);
    // AllowCatDelegate
    allowCatDelegate = new AllowCatDelegate(this);
    delegates.insert(AbstractDelegate::AllowCat, allowCatDelegate);
    // AllowTsDelegate
    allowTsDelegate = new AllowTsDelegate(this);
    delegates.insert(AbstractDelegate::AllowTs, allowTsDelegate);
    // SaveDelegate
    saveDelegate = new SaveDelegate(this);
    delegates.insert(AbstractDelegate::Save, saveDelegate);
    // MultiSelectDelegate
    multiSelectDelegate = new MultiSelectDelegate(this);
    delegates.insert(AbstractDelegate::MultiSelect, multiSelectDelegate);
    // AppendDelegate
    appendDelegate = new AppendDelegate(this);
    delegates.insert(AbstractDelegate::Append, appendDelegate);
    // AlignmentDelegate
    alignmentDelegate = new AlignmentDelegate(this);
    delegates.insert(AbstractDelegate::Alignment, alignmentDelegate);
    // RadioPositionDelegate
    radioPositionDelegate = new RadioPositionDelegate(this);
    delegates.insert(AbstractDelegate::RadioPosition, radioPositionDelegate);
    // ComboBoxTypeDelegate
    comboBoxTypeDelegate = new ComboBoxTypeDelegate(this);
    delegates.insert(AbstractDelegate::ComboBoxType, comboBoxTypeDelegate);
    // ContentsDelegate
    contentsDelegate = new ContentsDelegate(this);
    delegates.insert(AbstractDelegate::Contents, contentsDelegate);
    // MaxForEditDelegate
    maxForEditDelegate = new MaxForEditDelegate(this);
    delegates.insert(AbstractDelegate::MaxForEdit, maxForEditDelegate);
    // IActionDelegate
    iActionDelegate = new IActionDelegate(this);
    delegates.insert(AbstractDelegate::IAction, iActionDelegate);
    // ListContentDelegate
    listContentDelegate = new ListContentDelegate(this);
    delegates.insert(AbstractDelegate::ListContent, listContentDelegate);
    // ValuesDelegate
    valuesDelegate = new ValuesDelegate(this);
    delegates.insert(AbstractDelegate::Values, valuesDelegate);
    // IncludeFileNameDelegate
    includeFileNameDelegate = new IncludeFileNameDelegate(this);
    delegates.insert(AbstractDelegate::IncludeFileName, includeFileNameDelegate);
    // DefineDefinitionDelegate
    defineDefinitionDelegate = new DefineDefinitionDelegate(this);
    delegates.insert(AbstractDelegate::DefineDefinition, defineDefinitionDelegate);
    // ScriptIActionListDelegate
    scriptIActionListDelegate = new ScriptIActionListDelegate(this);
    delegates.insert(AbstractDelegate::ScriptIActionListDelegate, scriptIActionListDelegate);
    // ProgramCodeDelegate
    programCodeDelegate = new ProgramCodeDelegate(this);
    delegates.insert(AbstractDelegate::ProgramCode, programCodeDelegate);
    // ColorDelegate
    colorDelegate = new ColorDelegate(this);
    delegates.insert(AbstractDelegate::Color, colorDelegate);
    // TargetDelegate
    targetDelegate = new TargetDelegate(this);
    delegates.insert(AbstractDelegate::Target, targetDelegate);
    // UActionDelegate
    uActionDelegate = new UActionDelegate(this);
    delegates.insert(AbstractDelegate::UAction, uActionDelegate);
    // DefaultNumValDelegate
    defaultNumValDelegate = new DefaultNumValDelegate(this);
    delegates.insert(AbstractDelegate::DefaultNumVal, defaultNumValDelegate);
    // DefaultStrValDelegate
    defaultStrValDelegate = new DefaultStrValDelegate(this);
    delegates.insert(AbstractDelegate::DefaultStrVal, defaultStrValDelegate);
    // FileButtonWidthDelegate
    fileButtonWidthDelegate = new FileButtonWidthDelegate(this);
    delegates.insert(AbstractDelegate::FileButtonWidth, fileButtonWidthDelegate);
    // PositionGeometryDataDelegate
    positionGeometryXYDataDelegate = new PositionGeometryXYDataDelegate(this);
    delegates.insert(AbstractDelegate::PositionGeometryXYData, positionGeometryXYDataDelegate);
    // PositionGeometryXSizeYSizeDataDelegate
    positionGeometryXSizeYSizeDataDelegate = new PositionGeometryXSizeYSizeDataDelegate(this);
    delegates.insert(AppendDelegate::PositionGeometryXSizeYSizeData, positionGeometryXSizeYSizeDataDelegate);
}

void ObjectPropertiesView::onSelectionChangedInObjectListTreeView(QItemSelection selected,
                                                                  QItemSelection deselected)
{
    Q_UNUSED(deselected)
    if (selected.isEmpty()) return;
    if (selected.at(0).indexes().isEmpty()) return;
    QModelIndex index = selected.at(0).indexes().at(0);
    AbstractObj *obj = static_cast<AbstractObj*>(index.internalPointer());
    for (int i=0; i<obj->propertiesCount(); i++)
    {
        AbstractDelegate::DelegateType delegateType = obj->propertyAt(i)->delegateForProperty();
        setItemDelegateForRow(i, delegates.value(delegateType));
    }
}
