#ifndef OBJECTPROPERTIESVIEW_H
#define OBJECTPROPERTIESVIEW_H

#include <QTreeView>
#include <QMap>

// Delegates
#include "genericstringdelegate.h"
#include "namedelegate.h"
#include "operatingsystemdelegate.h"
#include "geometrydatadelegate.h"
#include "nomemorydelegate.h"
#include "groupboxdelegate.h"
#include "numonlydelegate.h"
#include "passworddelegate.h"
#include "allowcatdelegate.h"
#include "allowtsdelegate.h"
#include "savedelegate.h"
#include "multiselectdelegate.h"
#include "appenddelegate.h"
#include "alignmentdelegate.h"
#include "radiopositiondelegate.h"
#include "comboboxtypedelegate.h"
#include "contentsdelegate.h"
#include "maxforeditdelegate.h"
#include "iactiondelegate.h"
#include "listcontentdelegate.h"
#include "valuesdelegate.h"
#include "includefilenamedelegate.h"
#include "definedefinitiondelegate.h"
#include "scriptiactionlistdelegate.h"
#include "programcodedelegate.h"
#include "colordelegate.h"
#include "targetdelegate.h"
#include "uactiondelegate.h"
#include "defaultnumvaldelegate.h"
#include "defaultstrvaldelegate.h"
#include "filebuttonwidthdelegate.h"
#include "positiongeometryxydatadelegate.h"
#include "positiongeometryxsizeysizedatadelegate.h"

class ObjectPropertiesView : public QTreeView
{
Q_OBJECT

public:
    explicit ObjectPropertiesView(QWidget *parent = 0);

public slots:
    void onSelectionChangedInObjectListTreeView(QItemSelection selected, QItemSelection deselected);

private:
    QMap<AbstractDelegate::DelegateType, AbstractDelegate*> delegates;

    // Delegates
    GenericStringDelegate *genericStringDelegate;
    NameDelegate *nameDelegate;
    OperatingSystemDelegate *operatingSystemDelegate;
    GeometryDataDelegate *geometryDataDelegate;
    NoMemoryDelegate *noMemoryDelegate;
    GroupBoxDelegate *groupBoxDelegate;
    NumOnlyDelegate *numOnlyDelegate;
    PasswordDelegate *passwordDelegate;
    AllowCatDelegate *allowCatDelegate;
    AllowTsDelegate *allowTsDelegate;
    SaveDelegate *saveDelegate;
    MultiSelectDelegate *multiSelectDelegate;
    AppendDelegate *appendDelegate;
    AlignmentDelegate *alignmentDelegate;
    RadioPositionDelegate *radioPositionDelegate;
    ComboBoxTypeDelegate *comboBoxTypeDelegate;
    ContentsDelegate *contentsDelegate;
    MaxForEditDelegate *maxForEditDelegate;
    IActionDelegate *iActionDelegate;
    ListContentDelegate *listContentDelegate;
    ValuesDelegate *valuesDelegate;
    IncludeFileNameDelegate *includeFileNameDelegate;
    DefineDefinitionDelegate *defineDefinitionDelegate;
    ScriptIActionListDelegate *scriptIActionListDelegate;
    ProgramCodeDelegate *programCodeDelegate;
    ColorDelegate *colorDelegate;
    TargetDelegate *targetDelegate;
    UActionDelegate *uActionDelegate;
    DefaultNumValDelegate *defaultNumValDelegate;
    DefaultStrValDelegate *defaultStrValDelegate;
    FileButtonWidthDelegate *fileButtonWidthDelegate;
    PositionGeometryXYDataDelegate *positionGeometryXYDataDelegate;
    PositionGeometryXSizeYSizeDataDelegate *positionGeometryXSizeYSizeDataDelegate;
};

#endif // OBJECTPROPERTIESVIEW_H
