#include "okobj.h"

// Properties
#include "genericplainstringproperty.h"
#include "genericlabeledstringproperty.h"

OkObj::OkObj()
    : AbstractObj(AbstractObj::Ok)
{
    GenericPlainStringProperty *nameProperty =
            new GenericPlainStringProperty("name", "Name", AbstractDelegate::Name);
    nameProperty->setValue("mybutton");
    appendProperty(nameProperty);

    GenericLabeledStringProperty *label =
            new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(label);

    GenericLabeledStringProperty *uActionProperty =
            new GenericLabeledStringProperty("uaction", "U-Action", AbstractDelegate::UAction);
    appendProperty(uActionProperty);

    GenericLabeledStringProperty *targetProperty =
            new GenericLabeledStringProperty("target", "Target", AbstractDelegate::Target);
    appendProperty(targetProperty);
}

QString OkObj::commandString() const
{
    return "OK" + standardInnerCommandString();
}

QString OkObj::commandNameForDisplayRoleData() const
{
    return "Ok button";
}

QString OkObj::typeNameForDomElement() const
{
    return "ok";
}

bool OkObj::hasName() const
{
    return true;
}

