#include "positionobj.h"

// Properties
#include "positiongeometrydataproperty.h"

PositionObj::PositionObj()
    : AbstractObj(AbstractObj::Position)
{
    PositionGeometryDataProperty *x =
            new PositionGeometryDataProperty(PositionGeometryDataProperty::X, true);
    x->setValue(".");
    appendProperty(x);

    PositionGeometryDataProperty *y =
            new PositionGeometryDataProperty(PositionGeometryDataProperty::Y, true);
    y->setValue(".");
    appendProperty(y);

    PositionGeometryDataProperty *xSize
            = new PositionGeometryDataProperty(PositionGeometryDataProperty::XSize, false);
    xSize->setValue("400");
    appendProperty(xSize);

    PositionGeometryDataProperty *ySize
            = new PositionGeometryDataProperty(PositionGeometryDataProperty::YSize, false);
    ySize->setValue("300");
    appendProperty(ySize);
}

QString PositionObj::commandString() const
{
    return "POSITION" + standardInnerCommandString();
}

QString PositionObj::commandNameForDisplayRoleData() const
{
    return "Position";
}

QString PositionObj::typeNameForDomElement() const
{
    return "position";
}

bool PositionObj::hasName() const
{
    return false;
}

