#include "programcodeproperty.h"

ProgramCodeProperty::ProgramCodeProperty()
{
    setValue("");
}

QVariant ProgramCodeProperty::updateDisplayRoleDataString(const QString &valueString)
{
    return valueString;
}

QString ProgramCodeProperty::updateCommandString(const QString &valueString)
{
    QString code = valueString;
    QStringList codeLines = code.split("\n", QString::SkipEmptyParts);
    QString returnString;
    returnString += "\nBEGIN";
    for (int i=0; i<codeLines.count(); i++)
        returnString += "\n  " + codeLines.at(i);
    returnString += "\nEND";
    return returnString;
}

QString ProgramCodeProperty::domElementName() const
{
    return "code";
}

QVariant ProgramCodeProperty::propertyNameForDisplayRoleData() const
{
    return "Code";
}

bool ProgramCodeProperty::isRequired() const
{
    return true;
}

AbstractDelegate::DelegateType ProgramCodeProperty::delegateForProperty() const
{
    return AbstractDelegate::ProgramCode;
}

void ProgramCodeProperty::setFromObjDomElement(const QDomElement &domElement)
{
    QDomNode domNode = domElement.namedItem(domElementName());
    if (domNode.isNull())
        setValue("");
    else
    {
        QString string;
        bool atLeastOneItem = false;
        QDomNode itemNode = domNode.toElement().firstChild();
        while (!itemNode.isNull())
        {
            if (itemNode.toElement().tagName() == "codeline")
            {
                if (atLeastOneItem)
                    string += "\n" + itemNode.childNodes().at(0).toText().data();
                else
                    string += itemNode.childNodes().at(0).toText().data();
                atLeastOneItem = true;
            }
            itemNode = itemNode.nextSibling();
        }
        setValue(string);
    }
}

QDomElement ProgramCodeProperty::domElement(QDomDocument &xmlDocument) const
{
    QDomElement domElement = xmlDocument.createElement(domElementName());

    if (value().isEmpty())
        return domElement;
    else
    {
        QStringList items = value().split("\n");
        for (int i=0; i<items.count(); i++)
        {
            QDomElement listItemElement = xmlDocument.createElement("codeline");
            QDomText listItemText = xmlDocument.createTextNode(items.at(i));
            listItemElement.appendChild(listItemText);
            domElement.appendChild(listItemElement);
        }
        return domElement;
    }
}

