#include "programobj.h"

// Properties
#include "genericplainstringproperty.h"
#include "programcodeproperty.h"

ProgramObj::ProgramObj()
    : AbstractObj(AbstractObj::Program)
{
    GenericPlainStringProperty *nameProperty
            = new GenericPlainStringProperty("name", "Name", AbstractDelegate::Name);
    nameProperty->setValue("mybutton");
    appendProperty(nameProperty);

    ProgramCodeProperty *programCodeProperty = new ProgramCodeProperty;
    appendProperty(programCodeProperty);
}

QString ProgramObj::commandString() const
{
    return "PROGRAM" + standardInnerCommandString();
}

QString ProgramObj::commandNameForDisplayRoleData() const
{
    return "Program";
}

QString ProgramObj::typeNameForDomElement() const
{
    return "program";
}

bool ProgramObj::hasName() const
{
    return true;
}
