#include "radioobj.h"

RadioObj::RadioObj()
    : AbstractControlObj(AbstractObj::Radio)
{
    xSizeProperty->setValue(".");
    ySizeProperty->setValue(".");

    radioPositionProperty = new RadioPositionProperty;
    appendProperty(radioPositionProperty);

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    defaultProperty =
            new GenericLabeledStringProperty("default", "Default", AbstractDelegate::DefaultNumVal);
    appendProperty(defaultProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    onClickOnProperty =
            new GenericLabeledStringProperty("onclickon", "On click on", AbstractDelegate::IAction);
    appendProperty(onClickOnProperty);

    onClickOffProperty =
            new GenericLabeledStringProperty("onclickoff", "On click off", AbstractDelegate::IAction);
    appendProperty(onClickOffProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString RadioObj::commandString() const
{
    return "RADIO" + standardInnerCommandString();
}

QString RadioObj::commandNameForDisplayRoleData() const
{
    return "Radio button";
}

QString RadioObj::typeNameForDomElement() const
{
    return "radio";
}
