#ifndef RADIOOBJ_H
#define RADIOOBJ_H

#include "abstractcontrolobj.h"

// Properties
#include "radiopositionproperty.h"
#include "genericlabeledstringproperty.h"
#include "genericbooleanproperty.h"

class RadioObj : public AbstractControlObj
{
public:
    RadioObj();

    // Re-implemented pure virtual functions
    virtual QString commandString() const;
    virtual QString commandNameForDisplayRoleData() const;
    virtual QString typeNameForDomElement() const;

    // Properties
    RadioPositionProperty *radioPositionProperty;
    GenericLabeledStringProperty *labelProperty;
    GenericLabeledStringProperty *errorProperty;
    GenericLabeledStringProperty *defaultProperty;
    GenericBooleanProperty *noMemoryProperty;
    GenericLabeledStringProperty *onClickOnProperty;
    GenericLabeledStringProperty *onClickOffProperty;
    GenericLabeledStringProperty *optionProperty;
    GenericLabeledStringProperty *toolTipProperty;
};

#endif // RADIOOBJ_H
