#include "spinnerobj.h"

SpinnerObj::SpinnerObj()
    : AbstractControlObj(AbstractObj::Spinner)
{
    xSizeProperty->setValue(".");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    defaultProperty =
            new GenericLabeledStringProperty("default", "Default", AbstractDelegate::DefaultNumVal);
    appendProperty(defaultProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    minForSpinnerProperty =
            new GenericLabeledStringProperty("min", "Min", AbstractDelegate::DefaultNumVal);
    appendProperty(minForSpinnerProperty);

    maxForSpinnerProperty =
            new GenericLabeledStringProperty("max", "Max", AbstractDelegate::DefaultNumVal);
    appendProperty(maxForSpinnerProperty);

    onChangeProperty =
            new GenericLabeledStringProperty("onchange", "On change", AbstractDelegate::IAction);
    appendProperty(onChangeProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString SpinnerObj::commandString() const
{
    return "SPINNER" + standardInnerCommandString();
}

QString SpinnerObj::commandNameForDisplayRoleData() const
{
    return "Spinner";
}

QString SpinnerObj::typeNameForDomElement() const
{
    return "spinner";
}
