#include "submitobj.h"

#include "genericplainstringproperty.h"
#include "genericlabeledstringproperty.h"

SubmitObj::SubmitObj()
    : AbstractObj(AbstractObj::Submit)
{
    GenericPlainStringProperty *nameProperty =
            new GenericPlainStringProperty("name", "Name", AbstractDelegate::Name);
    nameProperty->setValue("mybutton");
    appendProperty(nameProperty);

    GenericLabeledStringProperty *uActionProperty =
            new GenericLabeledStringProperty("uaction", "U-Action", AbstractDelegate::UAction);
    appendProperty(uActionProperty);

    GenericLabeledStringProperty *targetProperty =
            new GenericLabeledStringProperty("target", "Target", AbstractDelegate::Target);
    appendProperty(targetProperty);
}

QString SubmitObj::commandString() const
{
    return "SUBMIT" + standardInnerCommandString();
}

QString SubmitObj::commandNameForDisplayRoleData() const
{
    return "Submit button";
}

QString SubmitObj::typeNameForDomElement() const
{
    return "submit";
}

bool SubmitObj::hasName() const
{
    return true;
}

