#include "varlistforcanvas.h"

VarListForCanvas::VarListForCanvas(const QRect &rect, const QWidget *widget)
    : AbstractObjForCanvas(rect), widget(widget)
{
    // Frame
    styleOptionFrame.initFrom(widget);
    styleOptionFrame.rect = rect;

    // Varlist button
    int varlistButtonXPosition = rect.x() + rect.width() - 18;
    int varlistButtonYPosition = rect.y() + 2;
    varlistButtonRect = QRect(varlistButtonXPosition, varlistButtonYPosition, 16, 16);
    varlistButtonPixmap.load(":/images/icons/varlistbutton.png");
}

void VarListForCanvas::draw(QPainter *painter) const
{
    // Frame
    widget->style()->drawPrimitive(QStyle::PE_Frame, &styleOptionFrame, painter, widget);

    // Varlist button
    widget->style()->drawItemPixmap(painter, varlistButtonRect, Qt::AlignLeft, varlistButtonPixmap);
}
