#include "varnameobj.h"

VarNameObj::VarNameObj()
    : AbstractControlObj(AbstractObj::VarName)
{
    xSizeProperty->setValue("200");
    ySizeProperty->setValue(".");

    labelProperty
            = new GenericLabeledStringProperty("label", "Label", AbstractDelegate::GenericString);
    appendProperty(labelProperty);

    errorProperty =
            new GenericLabeledStringProperty("error", "Error", AbstractDelegate::GenericString);
    appendProperty(errorProperty);

    defaultProperty =
            new GenericLabeledStringProperty("default", "Default", AbstractDelegate::DefaultStrVal);
    appendProperty(defaultProperty);

    noMemoryProperty =
            new GenericBooleanProperty("nomemory", "No memory", AbstractDelegate::NoMemory);
    appendProperty(noMemoryProperty);

    allowCatProperty
            = new GenericBooleanProperty("allowcat", "Allow xi-style", AbstractDelegate::AllowCat);
    appendProperty(allowCatProperty);

    allowTsProperty
            = new GenericBooleanProperty("allowts", "Allow ts operators", AbstractDelegate::AllowTs);
    appendProperty(allowTsProperty);

    optionProperty =
            new GenericLabeledStringProperty("option", "Option", AbstractDelegate::GenericString);
    appendProperty(optionProperty);

    toolTipProperty =
            new GenericLabeledStringProperty("tooltip", "Tooltip", AbstractDelegate::GenericString);
    appendProperty(toolTipProperty);
}

QString VarNameObj::commandString() const
{
    return "VARNAME" + standardInnerCommandString();
}

QString VarNameObj::commandNameForDisplayRoleData() const
{
    return "Var name";
}

QString VarNameObj::typeNameForDomElement() const
{
    return "varname";
}

