#include "versionobj.h"

// Properties
#include "genericplainstringproperty.h"
#include "operatingsystemproperty.h"

VersionObj::VersionObj()
    : AbstractObj(AbstractObj::Version)
{
    GenericPlainStringProperty *versionNumberProperty
            = new GenericPlainStringProperty("versionnumber", "Number");
    versionNumberProperty->setValue("9.0");
    appendProperty(versionNumberProperty);

    OperatingSystemProperty *operatingSystemProperty = new OperatingSystemProperty;
    appendProperty(operatingSystemProperty);
}

QString VersionObj::commandString() const
{
    return "VERSION" + standardInnerCommandString();
}

QString VersionObj::commandNameForDisplayRoleData() const
{
    return "Version";
}

QString VersionObj::typeNameForDomElement() const
{
    return "version";
}

bool VersionObj::hasName() const
{
    return false;
}
